
%global meadversion 1.0.2
%global namedversion 1.0.2.GA-redhat-1
%global meadalpha .GA_redhat_1
%global meadrel .1
%global serial 1

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without mead

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define section free
%define upstreamreltag .GA
%global upstreamversion %{version}%{?upstreamreltag}
%define reltag %{?upstreamreltag}_redhat_1
%define namedreltag -redhat-1
%global namedversion %{upstreamversion}%{namedreltag}

%define maven_version 1.0.2.GA-redhat-1

Name:           jboss-stdio
Version:        1.0.2
Release:        1%{?reltag}%{?dist}
Epoch:          0
Summary:        JBoss STDIO
Group:          Development/Libraries

%if %with mead
Source100: jboss-stdio-1.0.2.GA-redhat-1-scm-sources.zip
Source102: jboss-stdio-1.0.2.GA-redhat-1.jar
Source103: jboss-stdio-1.0.2.GA-redhat-1.pom
Source104: jboss-stdio-1.0.2.GA-redhat-1-javadoc.jar
Source105: jboss-stdio-1.0.2.GA-redhat-1-sources.jar
%endif

License:        LGPLv2+
URL:            https://github.com/dmlloyd/jboss-stdio/tree/1.0.0.GA
%if %without mead
git clone git://git.app.eng.bos.redhat.com/jbossas/jboss-stdio.git && cd jboss-stdio && git checkout 1.0.2.GA && cd .. && rm -rf jboss-stdio/.git && tar cjf jboss-stdio-1.0.2.GA.tar.bz2 \
jboss-stdio
Source0:        jboss-stdio-1.0.2.GA.tar.bz2
Patch0:         jboss-stdio-vman-pom.patch
%endif

Requires(post): jpackage-utils 
Requires(postun): jpackage-utils 
Requires:       jpackage-utils

BuildRequires:  jpackage-utils 
%if %without mead
BuildRequires:  java-devel
BuildRequires:  maven2
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire-maven
BuildRequires:  maven2-plugin-source
BuildRequires:  jboss-parent
%endif

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss STDIO.

%if %without mead
%package javadoc
Group:          Documentation

Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n jboss-stdio
%patch0 -p1 -b .sav0
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        deploy javadoc:aggregate
%endif

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
%if %without mead
cp -p target/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
cp -p target/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%else
cp -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
cp -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `echo $jar| sed "s|-%{namedversion}||g"`; done)

# poms
mkdir -p %{buildroot}%{_mavenpomdir}
%if %without mead
cp -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%else
cp -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%endif
%add_to_maven_depmap org.jboss.stdio jboss-stdio %{namedversion} JPP %{name}

%if %without mead
# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if 0
%{jar} xf %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -C %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%endif
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %without mead
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Jul 29 2013 Paul Gier <pgier@redhat.com> - 0:1.0.2-1.GA_redhat_1
- Upgrade to version 1.0.2.GA

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-7.GA_redhat_2
- Rebuild for MD5

* Mon Aug 20 2012 Honza Brazdil <jbrazdil@redhat.com> - 0:1.0.1-6.GA_redhat_2
- Update pom patch for eap 6.0.1

* Sun Aug 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-5.GA_redhat_2.2
- Rebuild unsigned

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-5.GA_redhat_1.1
- Rebuild using cache signing

* Mon Jun 11 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-5.GA_redhat_1
- Rebuild for RHEL-5

* Thu Apr 19 2012 Lin Gao <lgao@redhat.com> - 0:1.0.1-4.GA_redhat_1
- Re vman to use jboss-parent:8-redhat-1

* Wed Feb 29 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-3.GA_redhat_1.1
- Populate java-signed

* Tue Feb 07 2012 Red Hat Release Engineering <release-engineering@redhat.com> - 0:1.0.1-3.GA_redhat_1
- Rebuild to use new signing key

* Mon Feb 06 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-2
- add javadoc subpackage
- add missing call to update maven depmap (fixes maven support)
- fix maven depmap
- fix missing sources (fixes non-MEAD build)
- fix install (fixes -bi --short-circuit)
- fix repolib file ownership

* Tue Jan 31 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-1.GA-redhat-1.1
- Do nor require maven2 at run-time
- Do not require jboss-parent
- Use new binaries signed with new key

* Fri Nov 11 2011 Lin Gao <lgao@redhat.com> - 0:1.0.1-1.GA-redhat-1
- upgrade to 1.0.1.GA
- build using mead

* Mon Aug 29 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-3.GA-redhat-1
- do not use variable in &lt;version&gt; in pom

* Mon Aug 29 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-2.GA-redhat-1
- wolf build

* Fri Jul 22 2011 Hui Wang <huwang@redhat.com> - 0:1.0.0-1.GA
- First release
